'placed in the Public Domain 5/24/97 John E. Carter 
'johnecarter@mindspring.com
'
'This source code requires PowerBasic 2.1 or later to compile
'
'unbacked.bas - ver 1.4 - 03/24/93 
'1.4  - 03/24/93 - added check to ignore networked drives
'1.3  - 03/17/93 - corrected file count in directories
'                - added display of free space on drive
'1.2  - 03/16/93 - added check to ignore "*.swp" files
'1.1  - 03/15/93 - corrected check for files in root directory
'1.0  - 03/08/93 

$string 1
$lib all off
$com 0
$stack 32766

'directory tree routine based on tree.bas by Eric Schonning   Fido 1:206/2505
'>this routine is freely passed into the public domain
'>for Power Basic users.  If you want to give me credit then
'>thats ok, but I don't expect it.
'>thanks go to Dave Navarro for help with the dta information

'this routine will create a complete tree listing for drive drv$
'using pb 2.1 dir$ command and dta information

dim dynamic dir.arr$(8000)  'array to hold directory info from dir$
dim thisdir$(8000)
dim quot$(8)
ver$ = "1.4x"
countall% = 0
shownames% = 0
totalfiles% = 0
totaldirs% = 0
cmd$ = ucase$(command$)
if cmd$<>"" then call parsecmd(cmd$)

color 7,0
cls
locate 1, 75
print ver$
print
print "Checking long term integrity of hard disk file storage"
print

nonarc& = 0    'size of all non-archived files on one drive
totnonarc& = 0 'size of all non-archived files on all disks
filelen& = 0
startime$ = time$

'determine how many drives are on PC, then check each drive for unbacked files
for drvnum% = 3 to 26            'start with drive C:, go to Z:
  reg %AX, &H3600
  reg %DX, drvnum%
  call interrupt &H21
  if reg(%AX) = &HFFFF then  'found actual last drive
    exit for
  else
    clusdrv& = reg(%DX)
    if clusdrv& < 0 then incr clusdrv&, 65536  'allow for big drives
    drvsize& = reg(%AX) * reg(%CX) * clusdrv&
    freebytes& = FNfreespace&(drvnum%)
    print using "#,###,###,###&&&";drvsize&;" total bytes on drive ";chr$(65 + drvnum% -1);":";
    print using "&#,###,###,###&";"    ";freebytes&;" bytes available"
  end if
next drvnum%
numdrvs% = drvnum% -3
for cur% = 3 to numdrvs% + 2
  drv$ = chr$(64 + cur%) + ":"
  isremote% = 0
  call checkremote(cur%, isremote%)
  if isremote% = 1 then
    print
    print "Skipping network drive ";drv$
    goto 99   'bug in iterate?
  end if
  nonarc& = 0
  if numdrvs% > 1 then
    print
    print "Checking local drive ";drv$
  end if
  td%=1  'total directories on drive, start at 1 for root dir
  call get.disk.tree(drv$)   ',td%)
  print
  if countfiles% = 1 then
    print using "##,###&##,###&";totalfiles%;" files in ";totaldirs%;" directories"
  end if
  print using "#,###,###,###&&";nonarc&;" bytes not backed up" ' on drive ";drv$
  incr totnonarc&, nonarc&
  totalfiles% = 0
  totaldirs% = 0
99 rem
next cur%
if numdrvs% > 1 then
  print
  print using "#,###,###,###&";totnonarc&;" total bytes not backed up on local drives";
end if
print
if totnonarc& > 5000000 then
  print
  beep
  color 14,0
  print "You need to do a tape backup of your PC as soon as possible."
  beep
'  sleep 5
  color 7,0
end if
print
print "Start: ";startime$,"End: ";time$
end

sub get.dta.addr(dtaseg%,dtaofs%) local
  'get disk transfer area address
  reg 1,&h2f00
  call interrupt &h21
  dtaseg%=reg(9)
  dtaofs%=reg(2)
end sub

sub get.disk.tree(chkdir$) local   ',td%) local
  shared dir.arr$(),drv$, filelen&, nonarc&, thisdir$(), countall%
  shared shownames%, totalfiles%, countfiles%, td%, totaldirs%
  'fa%=file attributes   tl%=total lines in dir
  'testdir$=directory to test
  fa%=0:tl%=0:chkdir$=ucase$(chkdir$):testdir$=""
  for xx% = 1 to 9
    test$ = test$ + chr$(xx%)
  next xx%
  do
    incr tl%
    if tl%=1 then
      if chkdir$=drv$ then       '    special handling for root directory
	testdir$=drv$+"\*.*"
	tk% = 0
	k$ = dir$(drv$ + "\*.*",32)
	while len(k$) > 0
	  incr tk%
	  thisdir$(tk%) = drv$ + "\" + k$
	  k$ = dir$
	wend
	for xx% = 1 to tk%   ' -1
	  k$ = thisdir$(xx%)
	  if instr(k$, any test$) > 0 then beep:?:?k$
	  if shownames% = 1 then ?k$,
	  incr totalfiles%
	  if countall% = 0 then
	    if right$(k$,3) <> "SWP" then
	      call justforjim(k$, filelen&)
	      incr nonarc&, filelen&
	    end if
	  else
	    call justforjim(k$, filelen&)
	    incr nonarc&, filelen&
	  end if
	next xx%
      else
	testdir$=chkdir$+"\*.*"
      end if
      dir.arr$(td%+1)=dir$(testdir$,16)
    else
      dir.arr$(td%+1)=dir$
    end if
    if dir.arr$(td%+1)="" then exit loop
    call get.dta.addr(dtaseg%,dtaofs%)
    def seg=dtaseg%
    fa%=peek(dtaofs%+21)
    def seg
    'test attribute for directory
    if (fa% and &b10000) then
      incr td%
      incr totaldirs%
      dir.arr$(td%)=chkdir$+"\"+dir.arr$(td%)
      tk% = 0
      k$ = dir$(dir.arr$(td%) + "\*.*",32)
      while len(k$) > 0
	incr tk%
	thisdir$(tk%) = dir.arr$(td%) + "\" + k$
	k$ = dir$
      wend
      for xx% = 1 to tk%  ' -1
	k$ = thisdir$(xx%)
	  if instr(k$, any test$) > 0 then beep:?:?k$
	if shownames% = 1 then ?k$,
	if countall% = 0 then
	  if right$(k$,3) <> "SWP" then
	    call justforjim(k$, filelen&)
	    incr nonarc&, filelen&
	  end if
	else
	  call justforjim(k$, filelen&)
	  incr nonarc&, filelen&
	end if
	incr totalfiles%
      next xx%

      'call it again to check for sub-directories off of current dir
      call get.disk.tree(dir.arr$(td%))  ',td%)
      'must set dir$ back to where we left off before recursive call
      for i%=1 to tl%
        if i%=1 then null$=dir$(testdir$,16) else null$=dir$
      next i%
      dir.arr$(td%+1)=" "  'so it won't exit out of loop prematurely
    end if
  loop while dir.arr$(td%+1) <> ""
end sub

'Sb: #167575-#EXISTS vs COMMAND$
'Fm: John Watts 73760,751
'To: Jim McKeown 76702,1102 (X)
'input "Enter filename ";FileName$                 ' Jim, give this a try
'call JustForJim( FileName$, FileLen& )
'if len(FileName$) then
'     print FileName$" is "FileLen&" bytes long."
'else
'     print "This file does not exist"
'end if
'end
sub JustForJim( FileName$, FileLen& )          ' This is just for Jim <g>
     if attrib(filename$) <> 32 then
       filelen& = 0
       exit sub
     end if
     FileName$ = DIR$(FileName$,32)            ' You have to use DIR$ first
     if filename$ = "" then
       filelen& = 0
       exit sub           ' because it moves the DTA
     end if
     reg(1),&h2f00                             ' if the file is found then
     call interrupt &h21                       ' locate the DTA and .....
     dta& = reg(9)*16+reg(2)+21
     map a$$ * 22,1 as attr$$,2 as t$$,2 as d$$,4 as s$$,13 as f$$
     def seg = 0           '       i        a        i         i
     a$$ =  peek$(dta&,22) '       m        t        z         l
     def seg               '       e        e        e         ename
     FileLen& = cvl(s$$)   '<-------------  Get the SIZE of the file
'after def seg = 0, if date$$, time$$ are set in a$$, then poke$, a$$, dta&
'then reg(1), &h2f01
'call interrupt &h21 will set the file's date and time to those values
'     tm = cvi(t$$)
'     ft$ = bin$(tm)
'     while len(ft$) < 16
'       ft$ = "0" + ft$
'     wend
'     print FNcvttime$(ft$)
'     dt = cvi(d$$)
'     fd$ = bin$(dt)
'     while len(fd$) < 16
'       fd$ = "0" + fd$
'     wend
'     print FNcvtdate$(fd$)
'     print "file time signature = ";FNcvtdate$(fd$);FNcvttime$(ft$)
end sub

'DEF FNcvtdate$(fd$)
''converts binary string in fd$ to mm-dd-yy
'day$ = right$(fd$,5)
'dy = FNbinconv(day$)
'mon$ = mid$(fd$,8,4)
'mo = FNbinconv(mon$)
'yr$ = left$(fd$,7)
'year = FNbinconv(yr$) + 1980
'mon$ = ltrim$(str$(mo,2))
'if mon < 10 then mon$ = "0" + mon$
'day$ = ltrim$(str$(dy,2))
'if dy < 10 then day$ = "0" + day$
'FNcvtdate$ = mon$ + day$ + ltrim$(str$(year,4))
'END DEF

'DEF FNcvttime$(ft$)
''converts binary string in ft$ to hh:mm:ss
'sec$ = right$(ft$,5)
'secs = FNbinconv(sec$) * 2
'tmin$ = mid$(ft$,6,6)
'mnt = FNbinconv(tmin$)
'hr$ = left$(ft$,5)
'hour = FNbinconv(hr$)
'hr$ = ltrim$(str$(hour,2))
'if hour < 10 then hr$ = "0" + hr$
'tmin$ = ltrim$(str$(mnt,2))
'if mnt < 10 then tmin$ = "0" + tmin$
'sec$ = ltrim$(str$(secs,2))
'if secs < 10 then sec$ = "0" + sec$
'FNcvttime$ = hr$ + tmin$ + sec$
'END DEF

'DEF FNbinconv(x$)
''converts binary string to numeric value
'LOCAL k,t, q
'k = 0
'q = len(x$)
'for t = 1 to len(x$)
'  if mid$(x$,t,1) = "1" then k = k + 2^q '(t-1)
'  decr q
'next t
'FNbinconv = k
'END DEF

'DEF FNcvtbin$(tm)
'k$ = string$(16,"0")
'for k = 16 to 1 step -1
'  if tm mod 2^(k-1) then
'    mid$(k$,k,1) = "1"
'    tm = tm - 2^(k-1) 'mod 2^k
'  end if
'next k
'FNcvtbin$ = k$
'END DEF

$include "regnames.inc"

SUB center(x$,xwid)
	'centers a line of text in specified field
	lx=(xwid-len(x$))/2
	x$ = space$(lx) + x$ + space$(lx)
	while len(x$) < xwid
	  x$ = x$ + " "
	wend
	if len(x$) > xwid then
	    x$ = left$(x$, xwid)
	end if
END SUB 'center

SUB parsecmd(x$)
  shared countall%, shownames%, countfiles%
  if instr(x$,"A") > 0 then incr countall%
  if instr(x$,"S") > 0 then incr shownames%
  if instr(x$,"C") > 0 then incr countfiles%
END SUB 'parsecmd



DEF FNfreespace&(drvno)
'call int &H21, function &H36 to get free space on drive 'drvno'
'0 = default drive, 1 = A, 2 = b, etc.
'on return, AX = sectors/cluster, BX = free clusters, CX = bytes/sector
'if AX = &HFFFF then error

  reg(%AX), &H3600                       'function number
  reg(%BX), 0
  reg(%CX), 0
  reg(%DX), drvno                        'drive number
  call interrupt &H21
  if reg(%AX) = -1 then
    print "Error accessing drive ";chr$(65 + drvno)
    beep
    end
  end if
  availclus& = reg(%BX)
  if availclus& < 0 then incr availclus&, 65536
  FNfreespace& = reg(%CX) * reg(%AX) * availclus&   'reg(%BX)
END DEF

SUB checkremote(cur%, isremote%)
  reg %ax, &H4409         'get local/remote status
  reg %bx, cur%
  call interrupt &h21
  if (reg(%dx) and 4096) then isremote% = 1
END SUB  'isremote
